;---------------------------------------------------------------------
;       Get segment address of IDE BIOS   ɂP񂾂R[
;---------------------------------------------------------------------
GetSeg_IDEBIOS  PROC    near
                mov     al,HiresoFlag
                test    al,1        ; --- Normal mode ---
                mov     cx,0DA00h   ; IDE work address (physical)
                mov     dx,0D800h   ; IDE BIOS address (physical)
                mov     ax,09800h   ; IDE BIOS address of memory window
                jz      NormalMode_IDE
                mov     cx,0E800h   ; IDE work address (physical)
                mov     bx,0E600h   ; IDE BIOS address (physical),ordinary
                mov     dx,063Dh
                in      al,dx
                test    al,2
                jz      @f
;;;;;;;;;       add     OffsetXcode,2000h       ; using adapter 
                mov     cx,0EA00h   ; IDE work address (physical)
        @@:     mov     dx,bx       ; 
                sub     bx,6000h    ; phisycal --> shadow
                mov     ax,bx       ; IDE BIOS address of memory window
NormalMode_IDE: mov     SegPhysIDEBIOS,dx
                mov     SegPhysIDEwork,cx
                mov     SegMMapIDEBIOS,ax
;                mov     es,ax
                ret
GetSeg_IDEBIOS  ENDP

;location_msg    DB      0E1h,"EXIDE ROM̾=",0
;--------------------------------------------------------
;       NOPCI_Check
;--------------------------------------------------------
NOPCI_Check     PROC    near
                xor     dx,dx
                mov     ax,0B101h       ; Get PCI BIOS status
                int     1Ah             ; PCI BIOS call
                jc      PCI_Check_fail
                cmp     dx,20494350h    ; ?dx=='PCI '
                jnz     PCI_Check_fail
                STC
                ret
PCI_Check_fail: CLC
                ret
NOPCI_Check     ENDP

;---------------------------------------------------------------------
;       Sector256Byte  256oCgݒ肩ǂ Ap3,486X(2䑕\@)p
;---------------------------------------------------------------------
Sector256Byte   PROC   near
                mov     dx,841Eh        ; \tgEFADIPXCb`
                in      al,dx
                and     al,01000000b    ; bit 6Y
                jz      Exist256BS      ; [Ȃ256Byte/sector
;                mov     cl,3
;                xor     ax,ax
;                mov     es,ax
;                mov     al,es:[0457h]
;               call    digitx2
                clc
                ret
Exist256BS:     mov     dx,offset msg_Sector256B
                call    _puts
                stc
                ret
Sector256Byte   ENDP
;CapaTooSmall    DB      0C1h,"@HDD̗eʂ܂. ",0


if 0
;--------------------------------------------------------
;       SetTone         
;--------------------------------------------------------
SetTone         PROC   near             ; ax= tone
                push    dx
                mov     DX,03FDBh       ; 3FDB
                out     DX,AL
                out     5Fh,al
                xchg    AL,AH
                out     DX,AL
                out     5Fh,al
                pop     dx
                ret
SetTone         ENDP
endif 

;--------------------------------------------------------
;       ShiftKeyCheck
;--------------------------------------------------------
ShiftKeyCheck   PROC    near
LoopPressShift: mov     ah,02h
                int 18h
                test    al,00011001b    ; 1=SHIFT, 8=GRPH, 16=CTRL
                jnz     LoopPressShift
                ret
ShiftKeyCheck   ENDP

;--------------------------------------------------------
;       GetDisplayLine       input   ES = VRAM segment
;--------------------------------------------------------
GetDisplayLine  PROC    near
                xor     ax,ax
                mov     ROW,MSG_DISP_LINE
                mov     COLUMN,ax
                mov     bx,3FE0h                ; ITF\sǗAhX
                mov     al,es:[bx]
                cmp     al,MSG_DISP_LINE
                ja      LineIndicatorInvalid
                inc     ax
                mov     ROW,ax
                add     ax,3
                mov     es:[bx],al
LineIndicatorInvalid:
                ret
GetDisplayLine  ENDP

;--------------------------------------------------------
;       Exist_IDE_BIOS
;--------------------------------------------------------
Exist_IDE_BIOS  PROC   near
                push    es
                mov     es,SegPhysIDEBIOS
                mov     ax,es:[0009h]   ; ? C-BUS ROM
                mov     bx,es:[000Bh]   ; ? C-BUS ROM
                pop     es
                cmp     ax,0AA55h       ; C-BUS ROM signature
                jnz     NoExist_IDE_BIOS
                cmp     bl,2Ah          ; C-BUS ROM type ID
                jnz     NoExist_IDE_BIOS
                clc
                ret
NoExist_IDE_BIOS:  
                mov     dx,offset absent_msg
                call    _puts
                stc
                ret
Exist_IDE_BIOS  ENDP



;--------------------------------------------------------------------
;       scan_pattern     ̔r[`    for IDE BIOS
;       <input>
;       DS:SI rp^[,         CX p^[̃oCg
;       ES:DI p^[ꏊ,         DX ͈̔̓oCg
;       <output>        < j AX,BX,CX,DX,DI >
;       CY =NONE ,  NC= ES:BX   carry0̂Ƃ  ES:BXɌoꏊԂ
;--------------------------------------------------------------------
scan_pattern     PROC    near
                cld
                mov     di,0040h
                sub     cx,si
                mov     dx,2000h-40h
                sub     dx,cx

                xor     bx,bx
                add     dx,di
scan_ent:       mov     ax,ds:[si]
                cmp     ax,es:[di]
                jnz     scan_No_match
                mov     bx,di
                push    cx
                push    si
                push    di
         repz   cmpsb
                or      cx,cx
                pop     di
                pop     si
                pop     cx
                jnz     scan_No_match
                clc                     ; scan OK
                ret
scan_No_match:  inc     di
                cmp     di,dx
                jb      scan_ent
                stc                     ; scan NG
                ret
scan_pattern     ENDP

;----------------------------------------------------------------------------
;       ScanFKEY_SHIFT  Vtg{FnL[Ń[hIEL 2018-12-24 ǉ
;----------------------------------------------------------------------------
ScanFKEY_SHIFT  PROC   near
                mov     es,SegTVRAM
; L[Ԃ݂    [SHIFT]+[FE1]`[FE6]e[h̊OlɑΉ
                xor     bx,bx
                mov     ax,040Ch    ; L[O[vb(STOP,COPY,F1,,F6)
                int 18h             ; L[{[hBIOSAO[vZX
                mov     cx,400h
        @@:     out     5Fh,al  ; ҂
               loop     @b
                mov     bl,ah
                mov     ax,040Ch    ; L[O[vb(STOP,COPY,F1,,F6)
                int 18h             ; L[{[hBIOSAO[vZX
                or      bl,ah
                mov     cx,400h 
        @@:     out     5Fh,al  ; ҂
               loop     @b
                mov     bl,ah
                mov     ax,040Eh    ; L[O[vd(SHIFT,CAPS,KANA,GRPH,CTRL)
                int 18h             ; L[{[hBIOSAO[vZX
                mov     bh,ah   ; ʕۑ
                cmp     bh,00000001b
                jnz     NoPressedSHIFT  ; VtgĂȂΎ
                mov     cx,6
       @@:      test    bl,80h          ; ŏʃrbg(FE6)璲ׂ
                jnz     PressedFKEY
                shl     bl,1
               loop     @b
                jmp     NoPressedSHIFT  ; 
PressedFKEY:    mov     al,cl           ; Vtg񐔂OlƂȂ
                dec     al              ; lɕϊ(-1)
                mov     ModeID,al       ; [hlm肷

                push    ax
                mov     al,0Dh          ; XCb`\ɂ
                out 68h,al
                pop     ax
                inc     al              ; [hlOlɕϊ
                mov     ah,es:[3FF6h]   ; XCb`Uǂݍ
                and     ah,11111000b    ; ̃rbgۑ̃}XN 
                or      al,ah           ; Yrbg͏㏑
                mov     es:[3FF6h],al   ; XCb`Uɏ
                call    Poop
                mov     al,0Ch          ; XCb`֎~ɂ
                out 68h,al
NoPressedSHIFT: ret
ScanFKEY_SHIFT  ENDP

if 1
;--------------------------------------------------------
;       Poop
;--------------------------------------------------------
Poop            PROC   near
;                mov     ax,4400       ; low freq.
;                call    SetTone
                mov     al,6            ; BEEP ON
                out 37h,al              
                mov     cx,6543h 
        @@:     out     5Fh,al  ; ҂
                out     5Fh,al
               loop     @b
                mov     al,7            ; BEEP OFF
                out 37h,al              
;                mov     ax,04CDh        ; normal freq.
;                call    SetTone
                ret
Poop            ENDP
endif
;----------------------------------------------------
;       DisplayParamMode
;----------------------------------------------------
DisplayParamMode        PROC   near
                mov     dx,offset msg_set 
                mov     es,SegTVRAM
                mov     al,byte ptr es:[3FF6h]
                test    al,00000111b
                jnz     @f
                mov     dx,offset msg_default
        @@:     call    _puts

                mov     dx,offset msg_param_is
                call    _puts
                mov     ah,0
                mov     al,ModeID       ; l
                inc     al              ; \͊Ol
                call    digitx1
                mov     al,ModeID
                mov     ah,0

                push    ax
                mov     ah,0
                inc     ax
                mov     al,1
                jae     safevalue
                mov     al,6
                jbe     safevalue
                mov     al,06h
                out 37h,al
                mov     al,0
safevalue:
                pop     ax

                shl     ax,1
                mov     bx,offset ParaMsgBase
                add     bx,ax
                mov     dx,ds:[bx]
                call    _puts           ; [hl̕񂩂\
                RET
mode1   DB      0E1h,"]  EXIDE(M9)[h(32255MBȏ16:255)",13,10,0
mode2   DB      0E1h,"]  SCSI EXIDE݃[h(SCSI4.3GBȏ)",13,10,0
mode3   DB      0E1h,"]  SCSI S݊[h(32GBȏ؎̂)",13,10,0
mode4   DB      0E1h,"]  SCSI ٺg[h(IFC-USP݊)",13,10,0
mode5   DB      0E1h,"]  SCSI SSDg[h(32GB`64GBƎ)",13,10,0
mode6   DB      0E1h,"]  SCSI SSD݃[h",13,10,0
mode7   DB      0E1h,"]  V_g[h",13,10,0
ParaMsgBase     label   word
                DW      offset mode1
                DW      offset mode2
                DW      offset mode3
                DW      offset mode4
                DW      offset mode5
                DW      offset mode6
                DW      offset mode7
                DW      offset mode7
DisplayParamMode        ENDP

;--------------------------------------------------------
;       DisplayTitle  ( Aps/As3/BA3/BX3/486X-matep )
;--------------------------------------------------------
DisplayTitle    PROC    near
                push    ROW
                push    COLUMN
                mov     ROW,0
                mov     COLUMN,74
;                mov     dx,offset location_msg
;                call    _puts
                mov     ax,cs:[00F8h]
                call    digitx
                pop     COLUMN
                pop     ROW
                mov     dx,offset title_msg
                call    _puts
                mov     al,MachineType
IF 0
                cmp     al,1
                je      MachineType1
                cmp     al,2
                je      MachineType2
                cmp     al,3
                je      MachineType3
                cmp     al,5
                je      MachineType5
ENDIF
                cmp     al,4
                je      MachineType4
                mov     dx,offset machine_typeUN
                mov     al,1
                mov     MachineType,al
                jmp     @f
IF 0
MachineType1:   mov     dx,offset machine_typeB3
                jmp     @f
MachineType2:   mov     dx,offset machine_typeX
                jmp     @f
MachineType3:   mov     dx,offset machine_typeA3
                jmp     @f
MachineType5:   mov     dx,offset machine_typeC
                jmp     @f
ENDIF
MachineType4:   mov     dx,offset machine_typeAn
;               jmp     @f
        @@:     call    _puts
                mov     dx,offset CRLF_msg
                call    _puts
                ret
DisplayTitle    ENDP
IF 0
;--------------------------------------------------------
;       ClearMEMseg
;--------------------------------------------------------
ClearMEMseg     PROC    near
                push    es
                mov     cx,2000h/2
                mov     ax,MEMseg
                mov     es,ax
                xor     ax,ax
                mov     di,ax
           rep  stosw
                pop     es
                ret
ClearMEMseg     ENDP
ENDIF
align 16
ParamTable1   label   byte                ;EXIDE(M9)[h
                DW      0811h  ; < 4351MB
                DW      0F3Fh  ; < 8192MB
                DW      0F3Fh  ; < 32255MB
                DW      10FFh  ; < 32768MB
                DW      10FFh  ; < 61440MB
                DW      10FFh  ; < 64GB
                DW      10FFh  ; < 122GB
                DW      10FFh  ; above
ParamTable2   label   byte                ;[h
                DW      0811h  ; < 4351MB
                DW      0820h  ; < 8192MB
                DW      0880h  ; < 32255MB
                DW      0880h  ; < 32768MB
                DW      10FFh  ; < 61440MB
                DW      10FFh  ; < 64GB
                DW      10FFh  ; < 122GB
                DW      10FFh  ; above
ParamTable3   label   byte   ; H:S  Capa    Ortho SCSI[h
                DW      0820h  ; < 4351MB
                DW      0820h  ; < 8192MB
                DW      0880h  ; < 32255MB
                DW      0880h  ; < 32768MB
                DW      0880h  ; < 61440MB
                DW      0880h  ; < 64GB
                DW      0880h  ; < 122GB
                DW      0880h  ; above
ParamTable4   label   byte   ; H:S  Capa    SCSIRIFC-USP/UPg[h
                DW      0820h  ; < 4351MB
                DW      0820h  ; < 8192MB
                DW      0880h  ; < 32255MB
                DW      0880h  ; < 32768MB
                DW      0F80h  ; < 61440MB
                DW      0FFFh  ; < 64GB
                DW      0FFFh  ; < 122GB
                DW      0FFFh  ; above
ParamTable5   label   byte   ; H:S  Capa    SCSI SSDœKg[h
                DW      0820h  ; < 4351MB
                DW      0820h  ; < 8192MB
                DW      0880h  ; < 32255MB
                DW      0880h  ; < 32768MB
                DW      1080h  ; < 61440MB
                DW      1080h  ; < 64GB
                DW      1080h  ; < 122GB
                DW      1080h  ; above
ParamTable6   label   byte   ; H:S  Capa    SCSI SSD[h
                DW      0811h  ; < 4351MB
                DW      0820h  ; < 8192MB
                DW      0880h  ; < 32255MB
                DW      0880h  ; < 32768MB
                DW      1080h  ; < 61440MB
                DW      1080h  ; < 64GB
                DW      10FFh  ; < 122GB
                DW      10FFh  ; above
ParamTable7   label   byte   ; H:S  Capa    䃂[h
                DW      0811h  ; < 4351MB
                DW      103Fh  ; < 8192MB
                DW      103Fh  ; < 32255MB
                DW     0103Fh  ; < 32768MB
                DW     0103Fh  ; < 61440MB
                DW     0103Fh  ; < 64GB
                DW     0103Fh  ; < 122GB
                DW     0103Fh  ; above

